Index: flex.c
===================================================================
--- flex.c	(.../tags/ctags-5.8)
+++ flex.c	(.../trunk)
@@ -78,9 +78,12 @@
 	KEYWORD_static,
 	KEYWORD_class,
 	KEYWORD_id,
+	KEYWORD_name,
 	KEYWORD_script,
 	KEYWORD_cdata,
-	KEYWORD_mx
+	KEYWORD_mx,
+	KEYWORD_fx,
+	KEYWORD_override
 } keywordId;
 
 /*	Used to determine whether keyword is valid for the token language and
@@ -116,7 +119,8 @@
 	TOKEN_CLOSE_SGML,
 	TOKEN_LESS_THAN,
 	TOKEN_GREATER_THAN,
-	TOKEN_QUESTION_MARK
+	TOKEN_QUESTION_MARK,
+	TOKEN_OPEN_NAMESPACE
 } tokenType;
 
 typedef struct sTokenInfo {
@@ -182,9 +186,12 @@
 	{ "static",		KEYWORD_static				},
 	{ "class",		KEYWORD_class				},
 	{ "id",			KEYWORD_id					},
+	{ "name",		KEYWORD_name				},
 	{ "script",		KEYWORD_script				},
 	{ "cdata",		KEYWORD_cdata				},
-	{ "mx",			KEYWORD_mx					}
+	{ "mx",			KEYWORD_mx					},
+	{ "fx",			KEYWORD_fx					},
+	{ "override",	KEYWORD_override			}
 };
 
 /*
@@ -196,6 +203,7 @@
 static boolean parseBlock (tokenInfo *const token, tokenInfo *const parent);
 static boolean parseLine (tokenInfo *const token);
 static boolean parseActionScript (tokenInfo *const token);
+static boolean parseMXML (tokenInfo *const token);
 
 static boolean isIdentChar (const int c)
 {
@@ -518,13 +526,15 @@
 
 					  if ( (d != '!' )  && 		/* is this the start of a comment? */
 					       (d != '/' )  &&	 	/* is this the start of a closing mx tag */
-					       (d != 'm' )    ) 	/* is this the start of a mx tag */
+					       (d != 'm' )  &&  	/* is this the start of a mx tag */
+					       (d != 'f' )  &&  	/* is this the start of a fx tag */
+					       (d != 's' )    ) 	/* is this the start of a spark tag */
 					  {
 						  fileUngetc (d);
 						  token->type = TOKEN_LESS_THAN;
 						  token->lineNumber = getSourceLineNumber ();
 						  token->filePosition = getInputFilePosition ();
-
+						  break;						
 					  }
 					  else
 					  {
@@ -582,10 +592,10 @@
 								  }
 							  }
 						  }
-						  else if (d == 'm')
+						  else if (d == 'm' || d == 'f' || d == 's' )
 						  {
 							  int e = fileGetc ();
-							  if ( e != 'x' ) 		/* continuing an mx tag */
+							  if ( (d == 'm' || d == 'f') && e != 'x' ) 		/* continuing an mx or fx tag */
 							  {
 								  fileUngetc (e);
 								  fileUngetc (d);
@@ -592,13 +602,14 @@
 								  token->type = TOKEN_LESS_THAN;
 								  token->lineNumber = getSourceLineNumber ();
 								  token->filePosition = getInputFilePosition ();
+								  break;
 							  }
 							  else
 							  {
-								  if (e == 'x')
+								  if ( (d == 'm' || d == 'f') && e == 'x' )
 								  {
 									  int f = fileGetc ();
-									  if ( f != ':' ) 		/* is this the start of a comment? */
+									  if ( f != ':' ) 		/* start of the tag */
 									  {
 										  fileUngetc (f);
 										  fileUngetc (e);
@@ -606,23 +617,38 @@
 										  token->type = TOKEN_LESS_THAN;
 										  token->lineNumber = getSourceLineNumber ();
 										  token->filePosition = getInputFilePosition ();
+										  break;
 									  }
 									  else
 									  {
-										  if (f == ':')
-										  {
-											  token->type = TOKEN_OPEN_MXML;
-											  token->lineNumber = getSourceLineNumber ();
-											  token->filePosition = getInputFilePosition ();
-										  }
+										  token->type = TOKEN_OPEN_MXML;
+										  token->lineNumber = getSourceLineNumber ();
+										  token->filePosition = getInputFilePosition ();
+										  break;
 									  }
 								  }
+								  if ( d == 's' && e == ':')    /* continuing a spark tag */
+								  {
+									  token->type = TOKEN_OPEN_MXML;
+									  token->lineNumber = getSourceLineNumber ();
+									  token->filePosition = getInputFilePosition ();
+									  break;
+								  }
+								  else
+								  {
+									  fileUngetc (e);
+									  fileUngetc (d);
+									  token->type = TOKEN_LESS_THAN;
+									  token->lineNumber = getSourceLineNumber ();
+									  token->filePosition = getInputFilePosition ();
+									  break;
+								  }
 							  }
 						  }
 						  else if (d == '/')
 						  {
 							  int e = fileGetc ();
-							  if ( e != 'm' ) 		/* continuing an mx tag */
+							  if ( !(e == 'm' || e == 'f' || e == 's' ))
 							  {
 								  fileUngetc (e);
 								  fileUngetc (d);
@@ -629,11 +655,12 @@
 								  token->type = TOKEN_LESS_THAN;
 								  token->lineNumber = getSourceLineNumber ();
 								  token->filePosition = getInputFilePosition ();
+								  break;
 							  }
 							  else
 							  {
 								  int f = fileGetc ();
-								  if ( f != 'x' ) 		/* continuing an mx tag */
+								  if ( (e == 'm' || e == 'f') && f != 'x' ) 		/* continuing an mx or fx tag */
 								  {
 									  fileUngetc (f);
 									  fileUngetc (e);
@@ -640,6 +667,7 @@
 									  token->type = TOKEN_LESS_THAN;
 									  token->lineNumber = getSourceLineNumber ();
 									  token->filePosition = getInputFilePosition ();
+									  break;
 								  }
 								  else
 								  {
@@ -654,17 +682,32 @@
 											  token->type = TOKEN_LESS_THAN;
 											  token->lineNumber = getSourceLineNumber ();
 											  token->filePosition = getInputFilePosition ();
+											  break;
 										  }
 										  else
 										  {
-											  if (g == ':')
-											  {
-												  token->type = TOKEN_CLOSE_MXML;
-												  token->lineNumber = getSourceLineNumber ();
-												  token->filePosition = getInputFilePosition ();
-											  }
+											  token->type = TOKEN_CLOSE_MXML;
+											  token->lineNumber = getSourceLineNumber ();
+											  token->filePosition = getInputFilePosition ();
+											  break;
 										  }
 									  }
+									  if ( e == 's' && f == ':')    /* continuing a spark tag */
+									  {
+										  token->type = TOKEN_CLOSE_MXML;
+										  token->lineNumber = getSourceLineNumber ();
+										  token->filePosition = getInputFilePosition ();
+										  break;
+									  }
+									  else
+									  {
+										  fileUngetc (f);
+										  fileUngetc (e);
+										  token->type = TOKEN_LESS_THAN;
+										  token->lineNumber = getSourceLineNumber ();
+										  token->filePosition = getInputFilePosition ();
+										  break;
+									  }
 								  }
 							  }
 						  }
@@ -1423,7 +1466,7 @@
 	boolean is_class = FALSE;
 	boolean is_terminated = TRUE;
 	boolean is_global = FALSE;
-	boolean is_prototype = FALSE;
+	/* boolean is_prototype = FALSE; */
 	vString *	fulltag;
 
 	vStringClear(saveScope);
@@ -1571,7 +1614,7 @@
 					 */
 					makeClassTag (name);
 					is_class = TRUE;
-					is_prototype = TRUE;
+					/* is_prototype = TRUE; */
 
 					/*
 					 * There should a ".function_name" next.
@@ -1982,10 +2025,81 @@
 	return TRUE;
 }
 
+static boolean parseNamespace (tokenInfo *const token)
+{
+	/*
+	 * If we have found a <, we know it is not a TOKEN_OPEN_MXML 
+	 * but it could potentially be a different namespace.
+	 * This means it will also have a closing tag, which will
+	 * mess up the parser if we do not properly recurse 
+	 * through these tags.
+	 */
+
+	if (isType (token, TOKEN_LESS_THAN))
+	{
+		readToken (token);
+	}
+
+	/*
+	 * Check if we have reached a other namespace tag
+	 *   <views:Object ... />
+	 * or
+	 *   <views:Object ... >
+	 *   </views:Object>
+	 */
+	if (isType (token, TOKEN_IDENTIFIER))
+	{
+		readToken (token);
+		if (isType (token, TOKEN_COLON))
+		{
+			readToken (token);
+			if ( ! isType (token, TOKEN_IDENTIFIER))
+			{
+				return TRUE;
+			}
+		}
+		else
+		{
+			return TRUE;
+		}
+	}
+	else
+	{
+		return TRUE;
+	}
+
+	/* 
+	 * Confirmed we are inside a namespace tag, so
+	 * process it until the close tag.
+	 *
+	 * But also check for new tags, which will either
+	 * be recursive namespaces or MXML tags
+	 */
+	do
+	{
+		if (isType (token, TOKEN_LESS_THAN))
+		{
+			parseNamespace (token);
+			readToken (token);
+		}
+		if (isType (token, TOKEN_OPEN_MXML))
+		{
+			parseMXML (token);
+		}
+		else
+		{
+			readToken (token);
+		}
+	} while (! (isType (token, TOKEN_CLOSE_SGML) || isType (token, TOKEN_CLOSE_MXML)) ); 
+
+	return TRUE;
+}
+
 static boolean parseMXML (tokenInfo *const token)
 {
 	tokenInfo *const name = newToken ();
 	tokenInfo *const type = newToken ();
+	boolean inside_attributes = TRUE;
 	/*
 	 * Detect the common statements, if, while, for, do, ...
 	 * This is necessary since the last statement within a block "{}"
@@ -2059,21 +2173,44 @@
 	readToken (token);
 	do
 	{
-		if (isType (token, TOKEN_OPEN_MXML))
+		if (isType (token, TOKEN_GREATER_THAN))
 		{
-			parseMXML (token);
+			inside_attributes = FALSE;
 		}
-		else if (isKeyword (token, KEYWORD_id))
+		if (isType (token, TOKEN_LESS_THAN))
 		{
-			/* = */
+			parseNamespace (token);
 			readToken (token);
+		}
+		else if (isType (token, TOKEN_OPEN_MXML))
+		{
+			parseMXML (token);
 			readToken (token);
+		}
+		else if (inside_attributes && (isKeyword (token, KEYWORD_id) || isKeyword (token, KEYWORD_name)))
+		{
+			if (vStringLength(name->string) == 0 )
+			{
+				/* 
+				 * If we have already created the tag based on either "name"
+				 * or "id" do not do it again.
+				 */
+				readToken (token);
+				readToken (token);
 
-			copyToken (name, token);
-			addToScope (name, type->string);
-			makeMXTag (name);
+				copyToken (name, token);
+				addToScope (name, type->string);
+				makeMXTag (name);
+			}
+			else
+			{
+				readToken (token);
+			}
 		}
-		readToken (token);
+		else
+		{
+			readToken (token);
+		}
 	} while (! (isType (token, TOKEN_CLOSE_SGML) || isType (token, TOKEN_CLOSE_MXML)) ); 
 
 	if (isType (token, TOKEN_CLOSE_MXML))
@@ -2154,6 +2291,33 @@
 		{
 			if (isType(token, TOKEN_KEYWORD))
 			{
+				if (isKeyword (token, KEYWORD_private)   ||
+				    isKeyword (token, KEYWORD_public)    ||
+				    isKeyword (token, KEYWORD_override)  )
+				{
+					/*
+					 * Methods can be defined as:
+					 *     private function f_name
+					 *     public override function f_name
+					 *     override private function f_name
+					 * Ignore these keywords if present.
+					 */
+					readToken (token);
+				}
+				if (isKeyword (token, KEYWORD_private)   ||
+				    isKeyword (token, KEYWORD_public)    ||
+				    isKeyword (token, KEYWORD_override)  )
+				{
+					/*
+					 * Methods can be defined as:
+					 *     private function f_name
+					 *     public override function f_name
+					 *     override private function f_name
+					 * Ignore these keywords if present.
+					 */
+					readToken (token);
+				}
+
 				switch (token->keyword)
 				{
 					case KEYWORD_function:	parseFunction (token); break;
@@ -2178,11 +2342,14 @@
 		{
 			parseMXML (token);
 		} 
-		if (isType (token, TOKEN_LESS_THAN))
+		else if (isType (token, TOKEN_LESS_THAN))
 		{
 			readToken (token);
 			if (isType (token, TOKEN_QUESTION_MARK))
 			{
+				/*
+				 * <?xml version="1.0" encoding="utf-8"?>
+				 */
 				readToken (token);
 				while (! isType (token, TOKEN_QUESTION_MARK) )
 				{
@@ -2190,6 +2357,19 @@
 				} 
 				readToken (token);
 			}
+			else if (isKeyword (token, KEYWORD_NONE))
+			{
+				/*
+				 * This is a simple XML tag, read until the closing statement
+				 * <something .... >
+				 * </something>
+				 */
+				readToken (token);
+				while (! isType (token, TOKEN_GREATER_THAN) )
+				{
+					readToken (token);
+				} 
+			}
 		} 
 		else 
 		{
Index: verilog.c
===================================================================
--- verilog.c	(.../tags/ctags-5.8)
+++ verilog.c	(.../trunk)
@@ -232,6 +232,7 @@
 		c = skipWhite (c);
 		if (c == '=')
 		{
+			c = skipWhite (vGetc ());
 			if (c == '{')
 				skipPastMatch ("{}");
 			else
Index: routines.c
===================================================================
--- routines.c	(.../tags/ctags-5.8)
+++ routines.c	(.../trunk)
@@ -757,13 +757,13 @@
 				else if (cp [0] != PATH_SEPARATOR)
 					cp = slashp;
 #endif
-				strcpy (cp, slashp + 3);
+				memmove (cp, slashp + 3, strlen (slashp + 3) + 1);
 				slashp = cp;
 				continue;
 			}
 			else if (slashp [2] == PATH_SEPARATOR  ||  slashp [2] == '\0')
 			{
-				strcpy (slashp, slashp + 2);
+				memmove (slashp, slashp + 2, strlen (slashp + 2) + 1);
 				continue;
 			}
 		}
Index: source.mak
===================================================================
--- source.mak	(.../tags/ctags-5.8)
+++ source.mak	(.../trunk)
@@ -33,6 +33,7 @@
 	main.c \
 	make.c \
 	matlab.c \
+	objc.c \
 	ocaml.c \
 	options.c \
 	parse.c \
@@ -95,6 +96,7 @@
 	main.$(OBJEXT) \
 	make.$(OBJEXT) \
 	matlab.$(OBJEXT) \
+	objc.$(OBJEXT) \
 	ocaml.$(OBJEXT) \
 	options.$(OBJEXT) \
 	parse.$(OBJEXT) \
Index: sort.c
===================================================================
--- sort.c	(.../tags/ctags-5.8)
+++ sort.c	(.../trunk)
@@ -109,7 +109,7 @@
 	if (fp != NULL)
 		fclose (fp);
 	if (msg == NULL)
-		error (FATAL | PERROR, cannotSort);
+		error (FATAL | PERROR, "%s", cannotSort);
 	else
 		error (FATAL, "%s: %s", msg, cannotSort);
 }
Index: vim.c
===================================================================
--- vim.c	(.../tags/ctags-5.8)
+++ vim.c	(.../trunk)
@@ -47,7 +47,8 @@
 	K_COMMAND,
 	K_FUNCTION,
 	K_MAP,
-	K_VARIABLE
+	K_VARIABLE,
+	K_FILENAME
 } vimKind;
 
 static kindOption VimKinds [] = {
@@ -56,6 +57,7 @@
 	{ TRUE,  'f', "function", "function definitions" },
 	{ TRUE,  'm', "map",      "maps" },
 	{ TRUE,  'v', "variable", "variable definitions" },
+	{ TRUE,  'n', "filename", "vimball filename" },
 };
 
 /*
@@ -226,6 +228,18 @@
 	return line;
 }
 
+static const unsigned char * readVimballLine (void)
+{
+	const unsigned char *line;
+
+	while ((line = fileReadLine ()) != NULL)
+	{
+		break;
+	}
+
+	return line;
+}
+
 static void parseFunction (const unsigned char *line)
 {
 	vString *name = vStringNew ();
@@ -362,6 +376,17 @@
 		if ((int) *cp == '!')
 			++cp;
 
+		if ((int) *cp != ' ')
+		{
+			/*
+			 * :command must be followed by a space.  If it is not, it is 
+			 * not a valid command.
+			 * Treat the line as processed and continue.
+			 */
+			cmdProcessed = TRUE;
+			goto cleanUp;
+		}
+
 		while (*cp && isspace ((int) *cp))
 			++cp; 
 	} 
@@ -389,11 +414,15 @@
 		else if (*cp == '-')
 		{
 			/* 
-			 * Read until the next space which sparates options or the name
+			 * Read until the next space which separates options or the name
 			 */
 			while (*cp && !isspace ((int) *cp))
 				++cp; 
 		}
+		else
+		{
+			++cp;
+		}
 	} while ( *cp &&  !isalnum ((int) *cp) );
 
 	if ( ! *cp )
@@ -600,7 +629,6 @@
 static void parseVimFile (const unsigned char *line)
 {
 	boolean readNextLine = TRUE;
-	line = readVimLine();
 
 	while (line != NULL)
 	{
@@ -612,19 +640,105 @@
 	}
 }
 
+static void parseVimBallFile (const unsigned char *line)
+{
+	vString *fname = vStringNew ();
+	const unsigned char *cp;
+	int file_line_count;
+	int i;
+
+	/*
+	 * Vimball Archives follow this format
+	 *    " Vimball Archiver comment
+	 *    UseVimball
+	 *    finish
+	 *    filename
+	 *    line count (n) for filename
+	 *    (n) lines
+	 *    filename
+	 *    line count (n) for filename
+	 *    (n) lines
+	 *    ...
+	 */
+
+	/* Next line should be "finish" */
+	line = readVimLine();
+	if (line == NULL)
+	{
+		return;
+	}
+	while (line != NULL)
+	{
+		/* Next line should be a filename */
+		line = readVimLine();
+		if (line == NULL)
+		{
+			return;
+		}
+		else
+		{
+			cp = line;
+			do
+			{
+				vStringPut (fname, (int) *cp);
+				++cp;
+			} while (isalnum ((int) *cp) ||  *cp == '.' ||  *cp == '/' ||	*cp == '\\');
+			vStringTerminate (fname);
+			makeSimpleTag (fname, VimKinds, K_FILENAME);
+			vStringClear (fname);
+		}
+
+		file_line_count = 0;
+		/* Next line should be the line count of the file */
+		line = readVimLine();
+		if (line == NULL)
+		{
+			return;
+		}
+		else
+		{
+			file_line_count = atoi( (const char *) line );
+		}
+
+		/* Read all lines of the file */
+		for ( i=0; i<file_line_count; i++ )
+		{
+			line = readVimballLine();
+			if (line == NULL)
+			{
+				return;
+			}
+		}
+	}
+
+	vStringDelete (fname);
+}
+
 static void findVimTags (void)
 {
 	const unsigned char *line;
-		/* TODO - change this into a structure */
+	/* TODO - change this into a structure */
 
-	line = '\0';
+	line = readVimLine();
 
-	parseVimFile (line);
+    if (line == NULL)
+    {
+            return;
+    }
+
+	if ( strncmp ((const char*) line, "UseVimball", (size_t) 10) == 0 )
+	{
+		parseVimBallFile (line);
+	}
+	else
+	{
+		parseVimFile (line);
+	}
 }
 
 extern parserDefinition* VimParser (void)
 {
-	static const char *const extensions [] = { "vim", NULL };
+	static const char *const extensions [] = { "vim", "vba", NULL };
 	parserDefinition* def = parserNew ("Vim");
 	def->kinds		= VimKinds;
 	def->kindCount	= KIND_COUNT (VimKinds);
Index: perl.c
===================================================================
--- perl.c	(.../tags/ctags-5.8)
+++ perl.c	(.../trunk)
@@ -14,6 +14,7 @@
 *   INCLUDE FILES
 */
 #include "general.h"  /* must always come first */
+#include "debug.h"
 
 #include <string.h>
 
@@ -64,28 +65,34 @@
 
 static boolean isPodWord (const char *word)
 {
-	boolean result = FALSE;
-	if (isalpha (*word))
-	{
-		const char *const pods [] = {
-			"head1", "head2", "head3", "head4", "over", "item", "back",
-			"pod", "begin", "end", "for"
-		};
-		const size_t count = sizeof (pods) / sizeof (pods [0]);
-		const char *white = strpbrk (word, " \t");
-		const size_t len = (white!=NULL) ? (size_t)(white-word) : strlen (word);
-		char *const id = (char*) eMalloc (len + 1);
-		size_t i;
-		strncpy (id, word, len);
-		id [len] = '\0';
-		for (i = 0  ;  i < count  &&  ! result  ;  ++i)
-		{
-			if (strcmp (id, pods [i]) == 0)
-				result = TRUE;
-		}
-		eFree (id);
+	/* Perl POD words are three to eight characters in size.  We use this
+	 * fact to find (or not find) the right side of the word and then
+	 * perform comparisons, if necessary, of POD words of that size.
+	 */
+	size_t len;
+	for (len = 0; len < 9; ++len)
+		if ('\0' == word[len] || ' ' == word[len] || '\t' == word[len])
+			break;
+	switch (len) {
+		case 3:
+			return 0 == strncmp(word, "end", 3)
+				|| 0 == strncmp(word, "for", 3)
+				|| 0 == strncmp(word, "pod", 3);
+		case 4:
+			return 0 == strncmp(word, "back", 4)
+				|| 0 == strncmp(word, "item", 4)
+				|| 0 == strncmp(word, "over", 4);
+		case 5:
+			return 0 == strncmp(word, "begin", 5)
+				|| 0 == strncmp(word, "head1", 5)
+				|| 0 == strncmp(word, "head2", 5)
+				|| 0 == strncmp(word, "head3", 5)
+				|| 0 == strncmp(word, "head4", 5);
+		case 8:
+			return 0 == strncmp(word, "encoding", 8);
+		default:
+			return FALSE;
 	}
-	return result;
 }
 
 /*
@@ -164,6 +171,98 @@
 	return FALSE;
 }
 
+/* `end' points to the equal sign.  Parse from right to left to get the
+ * identifier.  Assume we're dealing with something of form \s*\w+\s*=>
+ */
+static void makeTagFromLeftSide (const char *begin, const char *end,
+	vString *name, vString *package)
+{
+	tagEntryInfo entry;
+	const char *b, *e;
+	for (e = end - 1; e > begin && isspace(*e); --e)
+		;
+	if (e < begin)
+		return;
+	for (b = e; b >= begin && isIdentifier(*b); --b)
+		;
+	/* Identifier must be either beginning of line of have some whitespace
+	 * on its left:
+	 */
+	if (b < begin || isspace(*b) || ',' == *b)
+		++b;
+	else if (b != begin)
+		return;
+	Assert(e - b + 1 > 0);
+	vStringClear(name);
+	vStringNCatS(name, b, e - b + 1);
+	initTagEntry(&entry, vStringValue(name));
+	entry.kind = PerlKinds[K_CONSTANT].letter;
+	entry.kindName = PerlKinds[K_CONSTANT].name;
+	makeTagEntry(&entry);
+	if (Option.include.qualifiedTags && package && vStringLength(package)) {
+		vStringClear(name);
+		vStringCopy(name, package);
+		vStringNCatS(name, b, e - b + 1);
+		initTagEntry(&entry, vStringValue(name));
+		entry.kind = PerlKinds[K_CONSTANT].letter;
+		entry.kindName = PerlKinds[K_CONSTANT].name;
+		makeTagEntry(&entry);
+	}
+}
+
+enum const_state { CONST_STATE_NEXT_LINE, CONST_STATE_HIT_END };
+
+/* Parse a single line, find as many NAME => VALUE pairs as we can and try
+ * to detect the end of the hashref.
+ */
+static enum const_state parseConstantsFromLine (const char *cp,
+	vString *name, vString *package)
+{
+	while (1) {
+		const size_t sz = strcspn(cp, "#}=");
+		switch (cp[sz]) {
+			case '=':
+				if (cp[sz + 1] && '>' == cp[sz + 1])
+					makeTagFromLeftSide(cp, cp + sz, name, package);
+				break;
+			case '}':	/* Assume this is the end of the hashref. */
+				return CONST_STATE_HIT_END;
+			case '\0':	/* End of the line. */
+			case '#':	/* Assume this is a comment and thus end of the line. */
+				return CONST_STATE_NEXT_LINE;
+		}
+		cp += sz + 1;
+	}
+}
+
+/* Parse constants declared via hash reference, like this:
+ * use constant {
+ *   A => 1,
+ *   B => 2,
+ * };
+ * The approach we take is simplistic, but it covers the vast majority of
+ * cases well.  There can be some false positives.
+ * Returns 0 if found the end of the hashref, -1 if we hit EOF
+ */
+static int parseConstantsFromHashRef (const unsigned char *cp,
+	vString *name, vString *package)
+{
+	while (1) {
+		enum const_state state =
+			parseConstantsFromLine((const char *) cp, name, package);
+		switch (state) {
+			case CONST_STATE_NEXT_LINE:
+				cp = fileReadLine();
+				if (cp)
+					break;
+				else
+					return -1;
+			case CONST_STATE_HIT_END:
+				return 0;
+		}
+	}
+}
+
 /* Algorithm adapted from from GNU etags.
  * Perl support by Bart Robinson <lomew@cs.utah.edu>
  * Perl sub names: look for /^ [ \t\n]sub [ \t\n]+ [^ \t\n{ (]+/
@@ -175,6 +274,18 @@
 	boolean skipPodDoc = FALSE;
 	const unsigned char *line;
 
+	/* Core modules AutoLoader and SelfLoader support delayed compilation
+	 * by allowing Perl code that follows __END__ and __DATA__ tokens,
+	 * respectively.  When we detect that one of these modules is used
+	 * in the file, we continue processing even after we see the
+	 * corresponding token that would usually terminate parsing of the
+	 * file.
+	 */
+	enum {
+		RESPECT_END		= (1 << 0),
+		RESPECT_DATA	= (1 << 1),
+	} respect_token = RESPECT_END | RESPECT_DATA;
+
 	while ((line = fileReadLine ()) != NULL)
 	{
 		boolean spaceRequired = FALSE;
@@ -195,9 +306,19 @@
 			continue;
 		}
 		else if (strcmp ((const char*) line, "__DATA__") == 0)
-			break;
+		{
+			if (respect_token & RESPECT_DATA)
+				break;
+			else
+				continue;
+		}
 		else if (strcmp ((const char*) line, "__END__") == 0)
-			break;
+		{
+			if (respect_token & RESPECT_END)
+				break;
+			else
+				continue;
+		}
 		else if (line [0] == '#')
 			continue;
 
@@ -219,11 +340,39 @@
 				continue;
 			while (*cp && isspace (*cp))
 				++cp;
+			if (strncmp((const char*) cp, "AutoLoader", (size_t) 10) == 0) {
+				respect_token &= ~RESPECT_END;
+				continue;
+			}
+			if (strncmp((const char*) cp, "SelfLoader", (size_t) 10) == 0) {
+				respect_token &= ~RESPECT_DATA;
+				continue;
+			}
 			if (strncmp((const char*) cp, "constant", (size_t) 8) != 0)
 				continue;
 			cp += 8;
+			/* Skip up to the first non-space character, skipping empty
+			 * and comment lines.
+			 */
+			while (isspace(*cp))
+				cp++;
+			while (!*cp || '#' == *cp) {
+				cp = fileReadLine ();
+				if (!cp)
+					goto END_MAIN_WHILE;
+				while (isspace (*cp))
+					cp++;
+			}
+			if ('{' == *cp) {
+				++cp;
+				if (0 == parseConstantsFromHashRef(cp, name, package)) {
+					vStringClear(name);
+					continue;
+				} else
+					goto END_MAIN_WHILE;
+			}
 			kind = K_CONSTANT;
-			spaceRequired = TRUE;
+			spaceRequired = FALSE;
 			qualified = TRUE;
 		}
 		else if (strncmp((const char*) cp, "package", (size_t) 7) == 0)
@@ -238,7 +387,7 @@
 				vStringClear (package);
 			while (isspace (*cp))
 				cp++;
-			while ((int) *cp != ';'  &&  !isspace ((int) *cp))
+			while (*cp && (int) *cp != ';'  &&  !isspace ((int) *cp))
 			{
 				vStringPut (package, (int) *cp);
 				cp++;
